'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Wrapper = require('./Wrapper');

var _Wrapper2 = _interopRequireDefault(_Wrapper);

var _List = require('../List');

var _List2 = _interopRequireDefault(_List);

var _ListItem = require('../ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _LoadingIndicator = require('../LoadingIndicator');

var _LoadingIndicator2 = _interopRequireDefault(_LoadingIndicator);

var _HomePageIconListItem = require('../HomePageIconListItem');

var _HomePageIconListItem2 = _interopRequireDefault(_HomePageIconListItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HomePageIconList = function (_Component) {
    _inherits(HomePageIconList, _Component);

    function HomePageIconList() {
        _classCallCheck(this, HomePageIconList);

        return _possibleConstructorReturn(this, (HomePageIconList.__proto__ || Object.getPrototypeOf(HomePageIconList)).apply(this, arguments));
    }

    _createClass(HomePageIconList, [{
        key: 'computeGrid',
        value: function computeGrid(numberOfItems) {
            var number = 1;
            if (numberOfItems === 2) {
                number = 6;
            } else if (numberOfItems === 3) {
                number = 4;
            } else if (numberOfItems === 4) {
                number = 3;
            } else if (numberOfItems === 5 || numberOfItems === 6) {
                number = 2;
            }
            return number;
        }
    }, {
        key: 'render',
        value: function render() {
            if (this.props.state === "loading") {
                return _react2.default.createElement(_List2.default, { component: _LoadingIndicator2.default });
            } else if (this.props.state === "error" || this.props.items.length === 0) {
                var ErrorComponent = function ErrorComponent() {
                    return _react2.default.createElement(_ListItem2.default, { item: 'Something went wrong, please try again!' });
                };
                return _react2.default.createElement(_List2.default, { component: ErrorComponent });
            } else {
                var columnWidth = this.computeGrid(this.props.items.length);

                var items = this.props.items.map(function (item) {
                    item.ref = item.identifier;
                    item.title = item.identifier;
                    item.columnWidth = columnWidth;
                    item.click = "nah";
                    item.icon = "crown-3";
                    return item;
                });

                return _react2.default.createElement(
                    _Wrapper2.default,
                    null,
                    _react2.default.createElement(_List2.default, { items: items, component: _HomePageIconListItem2.default })
                );
            }
        }
    }]);

    return HomePageIconList;
}(_react.Component);

HomePageIconList.defaultProps = {
    state: "loading",
    items: []
};

HomePageIconList.propTypes = {
    state: _propTypes2.default.string,
    items: _propTypes2.default.any
};

exports.default = HomePageIconList;