'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Ul = require('./Ul');

var _Ul2 = _interopRequireDefault(_Ul);

var _Wrapper = require('./Wrapper');

var _Wrapper2 = _interopRequireDefault(_Wrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function List(props) {
    var ComponentToRender = props.component;
    var content = _react2.default.createElement('div', null);

    // If we have items, render them
    if (props.items) {
        content = props.items.map(function (item) {
            return _react2.default.createElement(ComponentToRender, { key: 'item-' + item.ref, item: item });
        });
    } else {
        // Otherwise render a single component
        content = _react2.default.createElement(ComponentToRender, null);
    }

    return _react2.default.createElement(
        _Wrapper2.default,
        null,
        _react2.default.createElement(
            _Ul2.default,
            null,
            content
        )
    );
}

List.propTypes = {
    component: _propTypes2.default.func.isRequired,
    items: _propTypes2.default.array
};

exports.default = List;